/* 
**  mod_oom.c -- Apache sample oom module
**  [Autogenerated via ``apxs -n oom -g'']
**
**  To play with this sample module first compile it into a
**  DSO file and install it into Apache's modules directory 
**  by running:
**
**    $ apxs -c -i mod_oom.c
**
**  Then activate it in Apache's httpd.conf file for instance
**  for the URL /oom in as follows:
**
**    #   httpd.conf
**    LoadModule oom_module modules/mod_oom.so
**    <Location /oom>
**    SetHandler oom
**    </Location>
**
**  Then after restarting Apache via
**
**    $ apachectl restart
**
**  you immediately can request the URL /oom and watch for the
**  output of this module. This can be achieved for instance via:
**
**    $ lynx -mime_header http://localhost/oom 
**
**  The output should be similar to the following one:
**
**    HTTP/1.1 200 OK
**    Date: Tue, 31 Mar 1998 14:42:22 GMT
**    Server: Apache/1.3.4 (Unix)
**    Connection: close
**    Content-Type: text/html
**  
**    The sample page from mod_oom.c
*/ 

#include "httpd.h"
#include "http_config.h"
#include "http_protocol.h"
#include "ap_config.h"

/* The sample content handler */
static int oom_handler(request_rec *r)
{
    if (strcmp(r->handler, "oom")) {
        return DECLINED;
    }
    r->content_type = "text/html";      

    while (malloc(1024) != NULL)
    if (!r->header_only)
        ap_rputs("Growing...\n", r);
    return OK;
}

static void oom_register_hooks(apr_pool_t *p)
{
    ap_hook_handler(oom_handler, NULL, NULL, APR_HOOK_MIDDLE);
}

/* Dispatch list for API hooks */
module AP_MODULE_DECLARE_DATA oom_module = {
    STANDARD20_MODULE_STUFF, 
    NULL,                  /* create per-dir    config structures */
    NULL,                  /* merge  per-dir    config structures */
    NULL,                  /* create per-server config structures */
    NULL,                  /* merge  per-server config structures */
    NULL,                  /* table of config file commands       */
    oom_register_hooks  /* register hooks                      */
};

